require 'ostruct'

class Account
	attr_accessor :state, :id, :number, :service, :country, :response, :currency, :country_code

	def initialize(id)
      self.state = 'reserved'
      self.id = id
      self.number = '55748576'
      self.service = OpenStruct.new
      self.country = OpenStruct.new
      self.service.slug = 'claro-postpay'
      self.country.code = 'gt'
      self.currency = "USD"
      self.country_code = 'gt'
  end

	def self.find(account_id)
		Account.new(account_id)
	end

	def transactions
		Transaction.new
	end

	def send(action)
		if action == 'start_query!'
			self.state = 'querying'
		else
			self
		end
	end

	def success
		self.state = 'ready'
	end

	def error
		self.state = 'error'
	end

	def queue_for_retry
		self.state = 'awaiting_retry'
	end

	def queue_for_wait_at_worker
		self.state = 'waiting_at_worker'
	end

end