module SidekiqStrategies

  class Helper
    attr_accessor :acc_handler

    def initialize(acc_handler, url_helper)
      @acc_handler = acc_handler
      self.class.send(:include, url_helper)
    end

    def reply_tube_name
      "#{@acc_handler.account.country.code}-#{@acc_handler.account.id}"
    end

    def request_tube_name
      @acc_handler.transaction.provider.queue
    end

    def queue_message
      @acc_handler.transaction.provider.queue_options.merge(
        {
          action:       @acc_handler.action_name,
          account:      @acc_handler.account.id,
          number:       @acc_handler.account.number,
          service:      @acc_handler.account.service.slug,
          fields:       @acc_handler.transaction.fields,
          retry_count:  @acc_handler.transaction.retry_count,
          request_tube: @acc_handler.transaction.provider.queue,
          reply_tube:   reply_tube_name,
          account_url:  account_url(@acc_handler.account)
        }
      )
    end

    def try_again?(exception)
      return false if @acc_handler.transaction.retry_count >= 2
      return exception[:retry_action] if exception.kind_of?(Hash)
      return exception.retry_action if exception.respond_to?(:retry_action)
      false
    end

    private

    def account_url(account)
      v1_account_url cc: account.country_code, slug: account.service.slug, id: account.id
    end

  end

end