# Load to simulate a rails environment
require './lib/dependencies'

module SidekiqStrategies
Rails.application.routes.url_helpers
	
	# Initialize helpers
	acc_handler = AccountHandler.new(2, 4, :query, 10, Spool::Publisher)
	bns_handler = BeanstalkdHandler.new
	helper = Helper.new(acc_handler, Rails.application.routes.url_helpers)

	# Assign watchers
	acc_handler.add_subscriber(Spool::Subscribers::RedisPubSubSubscriber.new)
	acc_handler.add_subscriber(Spool::Subscribers::EventsAgentSubscriber.new)

	# Define external dependencies
	logger = Sidekiq.logger
	airbrake_notifier = Airbrake

	# Initiailze strategy executor
	strategy = PollingStrategy.new(acc_handler, bns_handler, logger, airbrake_notifier, helper)

	# Run strategy
	strategy.perform('56dg4df68g')

end